
#include <allegro.h>

/* Allegro ------------------------------------------------------------------ */

extern int allegro_initialize(void) { return allegro_init(); }

extern int allegro_initialize_cmdline(void) {
    return install_allegro(SYSTEM_NONE, &errno, atexit);
}

extern char* get_allegro_error(void) { return allegro_error; }

extern int get_allegro_date(void) { return ALLEGRO_DATE; }

extern char* get_allegro_id(void) { return allegro_id; }

extern int   get_cpu_capabilities(void) { return cpu_capabilities; }
extern int   get_cpu_family(void) { return cpu_family; }
extern int   get_cpu_model(void) { return cpu_model; }
extern char* get_cpu_vendor(void) { return cpu_vendor; }

extern int get_os_multitasking(void) { return os_multitasking; }

extern int get_os_type(void) { return os_type; }
extern int get_os_version(void) { return os_version; }
extern int get_os_revision(void) { return os_revision; }

extern int get_allegro_version(void)     { return ALLEGRO_VERSION;     }
extern int get_allegro_sub_version(void) { return ALLEGRO_SUB_VERSION; }
extern int get_allegro_wip_version(void) { return ALLEGRO_WIP_VERSION; }

/* Allegro.Fixed_Point_Math ------------------------------------------------- */

extern fixed get_fixtorad_r(void) { return fixtorad_r; }

extern fixed get_radtofix_r(void) { return radtofix_r; }

/* Allegro.Text_IO ---------------------------------------------------------- */

extern int get_allegro_404_char(void) { return allegro_404_char; }

extern FONT* get_font(void) { return font; }

extern void set_allegro_404_char(int c) { allegro_404_char = c; }

extern void set_font(FONT* f) { font = f; }

/* Allegro.Graphics --------------------------------------------------------- */

extern int get_gfx_capabilities(void) { return gfx_capabilities; }

/* Allegro.Bitmaps ---------------------------------------------------------- */

extern BITMAP* get_screen(void) { return screen; }

extern int get_screen_w(void) { return SCREEN_W; }

extern int get_screen_h(void) { return SCREEN_H; }

extern int get_virtual_w(void) { return VIRTUAL_W; }

extern int get_virtual_h(void) { return VIRTUAL_H; }

// Direct access to memory bitmap data

extern int memory_getpixel_15_or_16_bpp(BITMAP *bmp, int x, int y) {
    return ((short *)bmp->line[y])[x];
}

extern int memory_getpixel_32(BITMAP *bmp, int x, int y) {
    return ((long *)bmp->line[y])[x];
}

extern void memory_putpixel_15_or_16_bpp(BITMAP *bmp, int x, int y, int color) {
    ((short *)bmp->line[y])[x] = color;
}

extern void memory_putpixel_32(BITMAP *bmp, int x, int y, int color) {
    ((long *)bmp->line[y])[x] = color;
}

/* Allegro.Keyboard --------------------------------------------------------- */

extern int get_key_shifts(void) { return key_shifts; }

extern int get_key_status(int indx) { return key[indx]; }

extern void set_key_led_flag(int flag) { key_led_flag = flag; }

extern void set_keyboard_callback(void *kcb) { keyboard_callback = kcb; }

extern void set_keyboard_lowlevel_callback(void *klcb) {
    keyboard_lowlevel_callback = klcb;
}

extern void set_keyboard_ucallback(void *kucb) { keyboard_ucallback = kucb; }

extern void set_three_finger_flag(int flag) { three_finger_flag = flag; }

/* Allegro.Mouse ------------------------------------------------------------ */

extern int get_mouse(int p) {
    if (p == 0) return mouse_x_focus;
    if (p == 1) return mouse_y_focus;
    if (p == 2) return mouse_x;
    if (p == 3) return mouse_y;
    if (p == 4) return mouse_z;
    if (p == 5) return mouse_b;
    if (p == 6) return mouse_pos;
    if (p == 7) return freeze_mouse_flag;
    return 0;
}

extern BITMAP* get_mouse_sprite(void) { return mouse_sprite; }

extern void set_mouse_callback(void (*callback)(int flags)) {
    mouse_callback = callback;
}

/* Allegro.Timers ----------------------------------------------------------- */

extern int get_retrace_count(void) { return retrace_count; }

/* Allegro.Palettes --------------------------------------------------------- */

extern int get_palette_color(int index) { return palette_color[index]; }
