
with Applications;                      use Applications;
with Debugging;                         use Debugging;
with GNAT.OS_Lib;
with Objects;
with Project;
with Support.Paths;                     use Support.Paths;

-- The Project package is not used here but it must be referenced to ensure its
-- compilation.
pragma Warnings( off, Project );

package body Engine is

    function Engine_Main( argc : Integer; argv : Address ) return Integer is
        pragma Unreferenced( argc, argv );
        app  : A_Application;
        stat : Integer := 0;
    begin
        app := Get_Application;
        Set_Working_Directory;

        if app.Init then
            app.Run( stat );
            app.Close;
        end if;

        Delete_Application;
        pragma Debug( Objects.Finalize );

        return stat;
    exception
        when e : others =>
            pragma Debug( Dbg( "Engine_Main Exception: ..." ) );
            pragma Debug( Dbg( e ) );
            GNAT.OS_Lib.OS_Exit( 1 );
    end Engine_Main;

end Engine;
