
with Entities.Players;                  use Entities.Players;
with Resources;                         use Resources;

package body Entities.Items is

    not overriding
    procedure Construct( this       : access Item;
                         width,
                         height     : Natural;
                         libName    : String;
                         firstFrame : String;
                         maxFrames  : Positive;
                         frameDelay : Time_Span ) is
    begin
        Entity(this.all).Construct( width, height, libName );
        this.firstFrame := this.lib.Get_Id( firstFrame );
        if this.firstFrame = 0 then
            raise RESOURCE_ERROR with "Image <" & firstFrame & "> not found in " &
                                      "tile library <" & libName & ">";
        end if;
        this.maxFrames := maxFrames;
        this.frameDelay := frameDelay;
        this.frame := this.firstFrame;
        this.physical := False;
        this.clipped := False;
    end Construct;

    ----------------------------------------------------------------------------

    not overriding
    function Get_Icon( this : access Item ) return A_Bitmap is
    begin
        return this.lib.Get_Bitmap( this.firstFrame );
    end Get_Icon;

    ----------------------------------------------------------------------------

    overriding
    procedure On_Collide( this : access Item; e : not null A_Entity ) is
    begin
        if e.all in Player'Class and then not this.editingMode then
            A_Item(this).Give_Item;
        end if;
    end On_Collide;

    ----------------------------------------------------------------------------

    overriding
    procedure Tick( this : access Item; upTime, dt : Time_Span ) is
    begin
        Entity(this.all).Tick( upTime, dt );
        if this.maxFrames > 1 then
            this.Set_Frame( this.firstFrame + ((upTime / this.frameDelay) mod this.maxFrames) );
        end if;
    end Tick;

    ----------------------------------------------------------------------------

    overriding
    procedure Object_Read( stream : access Root_Stream_Type'Class; obj : out Item ) is
    begin
        Entity'Read( stream, Entity(obj) );
    end Object_Read;

    ----------------------------------------------------------------------------

    overriding
    procedure Object_Write( stream : access Root_Stream_Type'Class; obj : Item ) is
    begin
        Entity'Write( stream, Entity(obj) );
    end Object_Write;

    ----------------------------------------------------------------------------

    procedure Delete( this : in out A_Item ) is
    begin
        Delete( A_Object(this) );
    end Delete;

end Entities.Items;
