
with Ada.Streams;                       use Ada.Streams;
with Allegro.Bitmaps;                   use Allegro.Bitmaps;

package Resources.Images is

    -- Returns True if the given format is supported. The format string is the
    -- image format file extension without a leading dot character.
    function Is_Format_Supported( format : String ) return Boolean;

    -- Loads the an image of the given format from a memory block. The format
    -- string is the image format file extension without a leading dot character.
    -- An exception is raised on error.
    function Load_From_Memory( format : String;
                               data   : not null access Stream_Element_Array
                             ) return A_Bitmap;

end Resources.Images;
