
package Tiles.Libraries.Packing is

    type A_Output_Proc is
        access procedure( msg : String );

    function Pack_Library( libName  : String;
                           compress : Boolean;
                           Output   : A_Output_Proc
                         ) return Boolean;
    pragma Precondition( libName'Length > 0 );

private

    -- Step 1: returns a tile library if manifest was successfully parsed
    function Parse_Manifest( libName  : String;
                             Put_Line : not null A_Output_Proc
                           ) return A_Tile_Library;
    pragma Precondition( libName'Length > 0 );

    -- Step 2: returns true if all referenced files exist
    function Check_Dependencies( this     : not null A_Tile_Library;
                                 Put_Line : not null A_Output_Proc
                               ) return Boolean;

    -- Step 3: returns true if index file successfully created
    function Write_Index( this     : not null A_Tile_Library;
                          Put_Line : not null A_Output_Proc ) return Boolean;

    -- Step 4: returns true if library archive was successfully created
    function Create_Archive( this     : not null A_Tile_Library;
                             compress : Boolean;
                             Put_Line : not null A_Output_Proc
                           ) return Boolean;

end Tiles.Libraries.Packing;
