
with Widgets.Menu_Items;                use Widgets.Menu_Items;

package Game_Views.Ked.Menubar is

    procedure Make_Menubar( view : not null A_Ked_View;
                            win  : not null A_Window );

    -- Call this when a new map is loaded to update the menu bar
    procedure Handle_New_Map( view : not null A_Ked_View );

    MENUBAR_HEIGHT : constant := 22;

private

    -- file menu

    procedure File_New( action : A_Menu_Action );

    procedure File_Open( action : A_Menu_Action );

    procedure File_Save( action : A_Menu_Action );

    procedure File_Saveas( action : A_Menu_Action );

    procedure File_Import( action : A_Menu_Action );

    procedure File_Quit( action : A_Menu_Action );

    -- world menu

    procedure World_Properties( action : A_Menu_Action );

    procedure World_Resize( action : A_Menu_Action );

    -- options menu

    procedure Options_Gridsnap( action : A_Menu_Action );

    procedure Options_PinkScene( action : A_Menu_Action );

    procedure Options_Outlines( action : A_Menu_Action );

    -- help menu

    procedure Help_About( action : A_Menu_Action );

    -- shortcuts

    procedure Shortcut_File_Import( action : A_Key_Action; handled : out Boolean );

    procedure Shortcut_File_New( action : A_Key_Action; handled : out Boolean );

    procedure Shortcut_File_Open( action : A_Key_Action; handled : out Boolean );

    procedure Shortcut_File_Quit( action : A_Key_Action; handled : out Boolean );

    procedure Shortcut_File_Save( action : A_Key_Action; handled : out Boolean );

    procedure Shortcut_Toggle_Filter( action : A_Key_Action; handled : out Boolean );

end Game_Views.Ked.Menubar;
