
with Tools;                             use Tools;

package Game_Views.Ked.Toolbar is

    -- Builds the GUI for the tool bar.
    procedure Make_Toolbar( view : not null A_Ked_View;
                            win  : not null A_Window );

    procedure Handle_New_Map( view : not null A_Ked_View );

    -- Call this procedure when the active tool has changed.
    procedure Handle_Tool_Changed( view : not null A_Ked_View;
                                   tool : not null A_Tool );

    TOOLBAR_WIDTH : constant := 22;

private

    procedure Action_Pin_Palette( action : A_Button_Action );

    procedure Action_Show_Items( action : A_Button_Action );

    procedure Action_Show_Enemies( action : A_Button_Action );

    procedure Action_Show_Matrices( action : A_Button_Action );

    procedure Action_Show_Tiles( action : A_Button_Action );

    procedure Action_Tool_Group( action : A_Button_Group_Action );

    procedure Action_Use_Pointer( action : A_Button_Action );

    procedure Action_Use_Switch_Tool( action : A_Button_Action );

    procedure Action_Use_Trigger_Tool( action : A_Button_Action );

end Game_Views.Ked.Toolbar;
