
--with Debugging;                         use Debugging;
with Events.Ked;                        use Events.Ked;
with Tools.Pointers;                    use Tools.Pointers;

package body Tools.Enemy_Spawners is

    function Create_Enemy_Spawner( id : String ) return A_Tool is
        this : constant A_Enemy_Spawner := new Enemy_Spawner;
    begin
        this.Construct( id );
        return A_Tool(this);
    end Create_Enemy_Spawner;

    ----------------------------------------------------------------------------

    overriding
    procedure Apply( this      : access Enemy_Spawner;
                     func      : Function_Type;
                     modifiers : Modifiers_Array;
                     first     : Boolean;
                     world     : not null A_World;
                     worldX,
                     worldY,
                     layer     : Integer ) is
        pragma Unreferenced( modifiers, layer );
        tool : A_Tool;
    begin
        if first then
            if func = Primary then
                if worldX >= 0 and then worldX < world.Get_Width and then
                   worldY >= 0 and then worldY < world.Get_Height
                then
                    world.Spawn_Entity( To_String( this.id ),
                                        Float(worldX), Float(worldY) );
                end if;
            elsif func = Secondary or else func = Tertiary then
                tool := Create_Pointer;
                Queue_Set_Tool( tool );
                Delete( tool );
            end if;
        end if;
    end Apply;

    ----------------------------------------------------------------------------

    not overriding
    procedure Construct( this : access Enemy_Spawner; id : String ) is
    begin
        Tool(this.all).Construct;
        this.id := To_Unbounded_String( id );
    end Construct;

    ----------------------------------------------------------------------------

    function Get_ID( this : not null access Enemy_Spawner'Class ) return String is
    begin
        return To_String( this.id );
    end Get_ID;

end Tools.Enemy_Spawners;
