
--with Debugging;                         use Debugging;
with Events.Ked;                        use Events.Ked;
with Tools.Paintbrushes;                use Tools.Paintbrushes;

package body Tools.Pointers is

    function Create_Pointer return A_Tool is
        this : constant A_Tool := new Pointer;
    begin
        this.Construct;
        return this;
    end Create_Pointer;

    ----------------------------------------------------------------------------

    overriding
    procedure Apply( this      : access Pointer;
                     func      : Function_Type;
                     modifiers : Modifiers_Array;
                     first     : Boolean;
                     world     : not null A_World;
                     worldX,
                     worldY,
                     layer     : Integer ) is
        pragma Unreferenced( this, modifiers );
        tool : A_Tool;
        tile : Integer;
    begin
        if first and then func = Secondary then
            tile := world.Get_Tile_Id( layer,
                                       worldX / world.Tile_Width,
                                       worldY / world.Tile_Width );
            tool := Create_Paintbrush( tile );
            Queue_Set_Tool( tool );
            Delete( tool );
        end if;
    end Apply;

end Tools.Pointers;
