
--with Debugging;                         use Debugging;
with Events.Ked;                        use Events.Ked;
with Preferences;                       use Preferences;
with Support;                           use Support;
with Tools.Pointers;                    use Tools.Pointers;

package body Tools.Trigger_Spawners is

    function Create_Trigger_Spawner return A_Tool is
        this : constant A_Tool := new Trigger_Spawner;
    begin
        this.Construct;
        return this;
    end Create_Trigger_Spawner;

    ----------------------------------------------------------------------------

    overriding
    procedure Apply( this      : access Trigger_Spawner;
                     func      : Function_Type;
                     modifiers : Modifiers_Array;
                     first     : Boolean;
                     world     : not null A_World;
                     worldX,
                     worldY,
                     layer     : Integer ) is
        pragma Unreferenced( modifiers, layer );

        ------------------------------------------------------------------------

        function Snap( n : Integer ) return Float is
        begin
            if Get_Pref( "gridsnap" ) then
                return Float(Support.Grid_Snap( n, Get_Pref( "gridsize" ) ));
            end if;
            return Float(n);
        end Snap;

        ------------------------------------------------------------------------

        pragma Unreferenced( this );
        tool : A_Tool;
    begin
        if first then
            if func = Primary then
                if worldX >= 0 and then worldX < world.Get_Width and then
                   worldY >= 0 and then worldY < world.Get_Height
                then
                    world.Spawn_Entity( "trigger.keen",
                                        Snap( worldX ), Snap( worldY ),
                                        world.Tile_Width * 2, world.Tile_Width * 2 );
                end if;
            elsif func = Secondary or else func = Tertiary then
                tool := Create_Pointer;
                Queue_Set_Tool( tool );
                Delete( tool );
            end if;
        end if;
    end Apply;

end Tools.Trigger_Spawners;
