
with Allegro.Keyboard;                  use Allegro.Keyboard;
with Game_Views;                        use Game_Views;
with Support;                           use Support;
with Version;
with Widgets.Buttons.Pushes;            use Widgets.Buttons.Pushes;
with Widgets.Containers.Windows;        use Widgets.Containers.Windows;
with Widgets.Labels;                    use Widgets.Labels;

package body Widgets.Containers.Panels.Dialogs.About is

    function Create_About_Dialog( view : not null access Game_Views.Game_View'Class;
                                  id   : String ) return A_Dialog is
        this : A_Dialog := new About_Dialog;
    begin
        this.Construct( view, id );
        return this;
    exception
        when others =>
            Delete( A_Widget(this) );
            raise;
    end Create_About_Dialog;

    ----------------------------------------------------------------------------

    overriding
    procedure Construct( this : access About_Dialog;
                         view : not null access Game_Views.Game_View'Class;
                         id   : String ) is
        button : A_Button;
        label  : A_Label;
    begin
        Dialog(this.all).Construct( view, id, "About Keen Editor", "" );
        this.Set_Layout_Center( 250, 125 );

        label := Create_Label( view, this.id & ":lblIcon", icon => "ked_icon" );
        label.Set_Layout_LTWH( 5, 5, 54, 54 );
        this.Add( A_Widget(label) );

        label := Create_Label( view, this.id & ":lblLine1", "Keen Editor" );
        label.Set_Layout_LTRB( 64, 5, 5, -20 );
        this.Add( A_Widget(label) );

        label := Create_Label( view, this.id & ":lblLine2", "v" & Version.Release );
        label.Set_Layout_LTRB( 64, 23, 5, -38 );
        this.Add( A_Widget(label) );

        label := Create_Label( view, this.id & ":lblLine3", "Kevin Wellwood (C) " & Version.Copyright_Year );
        label.Set_Layout_LTRB( 64, 41, 5, -56 );
        this.Add( A_Widget(label) );

        button := Create_Push_Button( view, this.id & ":btnOk", "OK" );
        button.Set_Layout_LTWH( -5, -5, 55, 20 );
        button.Add_Listener( A_Button_Listener(this) );
        this.Add( A_Widget(button) );
    end Construct;

    ----------------------------------------------------------------------------

    overriding
    procedure Handle_Action( this   : access About_Dialog;
                             action : A_Button_Action ) is
    begin
        if action.Get_Id = Click then
            this.Hide;
        end if;
    end Handle_Action;

    ----------------------------------------------------------------------------

    overriding
    procedure Handle_Action( this    : access About_Dialog;
                             action  : A_Key_Action;
                             handled : out Boolean ) is
    begin
        if action.Get_Key = KEY_ESC and then action.Get_Id = Key_Press then
            this.Hide;
            handled := True;
        else
            Dialog(this.all).Handle_Action( action, handled );
        end if;
    end Handle_Action;

    ----------------------------------------------------------------------------

    overriding
    procedure Show( this : access About_Dialog ) is
    begin
        Dialog(this.all).Show;
        this.Get_Window.Give_Focus( this.Get_View.Get_Widget( this.id & ":btnOk" ) );
    end Show;

end Widgets.Containers.Panels.Dialogs.About;
