
with Interfaces.C;                      use Interfaces.C;

package body LoadPNG is

    function LoadPNG_Version return String is
    begin
        return "1.5";
    end LoadPNG_Version;

    ---------------------------------------------------------------------------

    procedure Set_PNG_Screen_Gamma( gamma : Long_Float ) is
        c_png_screen_gamma : Long_Float;
        pragma Import( C, c_png_screen_gamma, "_png_screen_gamma" );
    begin
        c_png_screen_gamma := gamma;
    end Set_PNG_Screen_Gamma;

    ---------------------------------------------------------------------------

    procedure Set_PNG_Compression_Level( level : Integer ) is
        c_png_compression_level : Integer;
        pragma Import( C, c_png_compression_level, "_png_compression_level" );
    begin
        c_png_compression_level := level;
    end Set_PNG_Compression_Level;

    ---------------------------------------------------------------------------

    function Load_PNG( filename : String; pal : A_RGB ) return A_Bitmap is
        function C_Load_PNG( filename : Interfaces.C.char_array; pal : A_RGB ) return A_Bitmap;
        pragma Import( C, C_Load_PNG, "load_png" );
    begin
        return C_Load_PNG( To_C( filename ), pal );
    end Load_PNG;

    ---------------------------------------------------------------------------

    function Save_PNG( filename : String; bmp : A_Bitmap; pal : A_RGB ) return Integer is
        function C_Save_PNG( filename : Interfaces.C.char_array; bmp : A_Bitmap; pal : A_RGB ) return Integer;
        pragma Import( C, C_Save_PNG, "save_png" );
    begin
        return C_Save_PNG( To_C( filename ), bmp, pal );
    end Save_PNG;

end LoadPNG;
