
--with Debugging;                         use Debugging;
with Maps;                              use Maps;

pragma Elaborate_All( Maps );

package body Maps.Keen is

    function Create_Map( width, height : Positive ) return A_Map is
        this : A_Keen_Map := new Keen_Map;
    begin
        this.Construct( width, height );
        return A_Map(this);
    exception
        when others =>
            Delete( A_Map(this) );
            raise;
    end Create_Map;

    ----------------------------------------------------------------------------

    not overriding
    procedure Construct( this : access Keen_Map; width, height : Positive ) is
    begin
        Map_Object(this.all).Construct( width, height, 3 );
        for i in this.layers'First..this.layers'First+1 loop
            this.layers(i).physical := True;
        end loop;
    end Construct;

    ----------------------------------------------------------------------------

    overriding
    function Object_Input( stream : access Root_Stream_Type'Class ) return Keen_Map is
        this : aliased Keen_Map;
    begin
        this.Construct;
        Keen_Map'Read( stream, this );
        return this;
    end Object_Input;

    ----------------------------------------------------------------------------

    overriding
    procedure Object_Read( stream : access Root_Stream_Type'Class; obj : out Keen_Map ) is
    begin
        Map_Object'Read( stream, Map_Object(obj) );
    end Object_Read;

    ----------------------------------------------------------------------------

    overriding
    procedure Object_Write( stream : access Root_Stream_Type'Class; obj : Keen_Map ) is
    begin
        Map_Object'Write( stream, Map_Object(obj) );
    end Object_Write;

begin

    Register_Allocator( Create_Map'Access );

end Maps.Keen;
